// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Linux 2.0.29 (Slackware 3.2) 
// vita'gasy
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _MY_OWN_BYTES	// My own bytes redfinitions ...
#define _MY_OWN_BYTES

  typedef unsigned char  _u8;
  typedef unsigned short _u16;
  typedef unsigned int   _u32;
  
#endif

//----------------- An Ethernet frame header --------------
#ifndef _LINUX_IF_ETHER_H	// User have not included linux/if_ether.h...
#define _LINUX_IF_ETHER_H

  #define ETH_ALEN	6		/* Octets in one ethernet addr	 */
  #define ETH_HLEN	14		/* Total octets in header.	 */
  struct ethhdr 
  {
	_u8	h_dest[ETH_ALEN];	/* destination eth addr	*/
	_u8	h_source[ETH_ALEN];	/* source ether addr	*/
	_u16	h_proto;		// IDfy packet type: IP,IPX,ARP,IPv6...
  };
  #define ETH_P_IP	0x0800		/* Internet Protocol packet	*/
  #define ETH_P_IPV6	0x86DD		/* IPv6 over bluebook		*/
  #define ETH_P_IPX	0x8137		/* IPX over DIX			*/
  #define ETH_P_ARP	0x0806		/* Address Resolution packet	*/
  #define ETH_P_RARP    0x8035		/* Reverse Addr Res packet	*/
  #define ETH_P_ALL	0x0003		/* Every packet (be careful!!!) */
 
#endif
/* And more in <linux/if_ether.h>					*/

#ifndef _LINUX_SOCKIOS_H                /* control iface ...            */
#define _LINUX_SOCKIOS_H

  /* Standard interface flags, pinched from <linux/if.h>                 */
  #define IFF_PROMISC     0x100         /* receive all packets           */

  /* Socket configuration controls, pinched from <linux/sockios.h>       */
  #define SIOCGIFFLAGS    0x8913        /* get flags                     */
  #define SIOCSIFFLAGS    0x8914        /* set flags                     */

#endif

//----------------- The IPv4 structure --------------
#ifndef _LINUX_IP_H		// User have not included linux/ip.h...
#define _LINUX_IP_H

  struct iphdr {
	_u8	ihl:4,		// iphdr len. (mul 4 will give the
		version:4;	// startin'of tcphdr ;), use it instead
				// of just +ing the iphdr struct size!
	_u8	tos;
	_u16	tot_len;        // total length of the IP Dgram.
	_u16	id;
	_u16	frag_off;       // 4 fragmentation packets...
	_u8	ttl;		// time to live
	_u8	protocol;	// IDfy transport layer prot.:TCP,UDP,ICMP...
	_u16	check;          // Internet standard checksum
	_u32	saddr;		// IP source in nbo
	_u32	daddr;		// IP dest.  in nbo
	/* The options start here. */
  };

#endif
//----------------- The TCP structure --------------
/* LITTLE_ENDIAN is used in x86 intel platform	   			*/
#ifndef _LINUX_TCP_H		// User have not included linux/tcp.h...
#define _LINUX_TCP_H

  struct tcphdr {
	_u16	source;		// source port
	_u16	dest;		// dest.  port
	_u32	seq;		// sender seq.
	_u32	ack_seq;	// recver ack_seq. 
	
	_u16	res1:4,
		doff:4,		// data_offset (mul 4 will give the
				// effective data ;), use it instead 
				// of just +ing the tcphdr struct size!
				
		fin:1,          // 4 closing a connection
		syn:1,          // initiating a connection...
		rst:1,       
		psh:1,          // data is sent & seq. is incremented   
		ack:1,          // 4 ack'ing the other hand
		urg:1,      
		res2:2;

	_u16	window;
	_u16	check;          // checksum 
	_u16	urg_ptr;
  };

#endif
//----------------- The UDP structure --------------
#ifndef _LINUX_UDP_H
#define _LINUX_UDP_H

  struct udphdr {
    _u16	source;		// source port
    _u16	dest;		// dest.  port
    _u16	len;            // data length + this struct. size
    _u16	check;          // checksum...
  };
  
#endif
//----------------- 4 computing checksum field in transport layer...
#ifndef _MY_OWN_CKSUM	// My checksum struct redfinition ...
#define _MY_OWN_CKSUM

struct cksum {
    _u32     src_addr;      // source host
    _u32     dst_addr;      // dest host
    _u8      placeholder;   // this is 4 memory displacement 
    _u8      protocol;      // the tr-protocol
    _u16     pr_length;     // tr-dgram length

    union {
      struct    udphdr  udp;           
      struct    tcphdr  tcp;           
    } ut;                   // size of all above is 32-bytes!
    
    _u8      buf[4096];     // 4Kb 4 the moment.  
};

#endif

//----------------- My own peer struct --------------
#ifndef _MY_PEER_H
#define _MY_PEER_H

struct hostpeer {

    _u16	id;		    // allows me 2 flood...
    _u32        saddr, daddr,       // IP_src & IP_dst

                seq, ack_seq;       // the Seq...
    _u16        source, dest;       // the ports

    _u8         fin:1,              // flags we're interested on...
                syn:1,              
                rst:1,
                ack:1,
                res1:4;
};

#endif
